//
// Title:   CoreResourceTools.cpp
// Created: Mon Sep 23 13:50:43 2002
// Authors: Oliver Knoll
//
// Copyright (c) 2001, 2002, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

#include "../ColorChooserTool/src/ColorChooserTool.h"
#include "../BrushChooserTool/src/BrushChooserTool.h"
#include "../BitmapManagerTool/src/BitmapManagerTool.h"

#include "CoreResourceTools.h"

// ******
// global
// ******

// the single CoreResourceTools instance, only
// accesible by getInstance() and
// destroyInstance()
static CoreResourceTools *instance = 0;

// *******************
// private c'tor/d'tor
// *******************

CoreResourceTools::CoreResourceTools() {};
CoreResourceTools::~CoreResourceTools() {};

// **************
// public methods
// **************

CoreResourceTools *CoreResourceTools::getInstance() {

	if (instance == 0) {
		instance = new CoreResourceTools();
	}
	return instance;

}

void CoreResourceTools::destroyInstance() {

	if (instance != 0) {
		delete instance;
	}
	instance = 0;

}

void CoreResourceTools::setColorChooserTool (ColorChooserTool *colorChooserTool) {
	this->colorChooserTool = colorChooserTool;
}

ColorChooserTool *CoreResourceTools::getColorChooserTool() {
	return colorChooserTool;
}

void CoreResourceTools::setBrushChooserTool (BrushChooserTool *brushChooserTool) {
	this->brushChooserTool = brushChooserTool;
}

BrushChooserTool *CoreResourceTools::getBrushChooserTool() {
	return brushChooserTool;
}


void CoreResourceTools::setBitmapManagerTool (BitmapManagerTool *brushChooserTool) {
    (void)brushChooserTool;
	this->bitmapManagerTool = bitmapManagerTool;
}

BitmapManagerTool *CoreResourceTools::getBitmapManagerTool() {
	return bitmapManagerTool;
}

// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
