//
// Title:   CoreTools.cpp
// Created: Mon Sep 23 13:49:09 2002
// Authors: Oliver Knoll
//
// Copyright (c) 2001, 2002, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

#include "../ColorPickerTool/src/ColorPickerTool.h"
#include "../SelectionTool/src/SelectionTool.h"
#include "CoreTools.h"

// ******
// global
// ******

// the single CoreTools instance, only
// accesible by getInstance() and
// destroyInstance()
static CoreTools *instance = 0;

// *******************
// private c'tor/d'tor
// *******************

CoreTools::CoreTools() {};
CoreTools::~CoreTools() {};

// **************
// public methods
// **************

CoreTools *CoreTools::getInstance() {

	if (instance == 0) {
		instance = new CoreTools();
	}
	return instance;

}

void CoreTools::destroyInstance() {

	if (instance != 0) {
		delete instance;
	}
	instance = 0;

}

void CoreTools::setColorPickerTool (ColorPickerTool *colorPickerTool) {
	this->colorPickerTool = colorPickerTool;
}

ColorPickerTool *CoreTools::getColorPickerTool() {
	return colorPickerTool;
}

void CoreTools::setSelectionTool (SelectionTool *selectionTool) {
	this->selectionTool = selectionTool;
}

SelectionTool *CoreTools::getSelectionTool() {
	return selectionTool;
}

// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
