/*
 * Title:   pisocket.h
 * Created: Tue Sep 24 18:12:15 2002
 * Authors: Gilbert Baumann, Markus Noga, Tim Weyrich
 *
 * Copyright (c) 2000--2002
 * Gilbert Baumann <unk6@rz.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 * 
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 */

#ifndef __pisocket_h__
#define __pisocket_h__

#include <pitypes.h>
#include <pisystem.h>

#ifdef _WIN32
//# include <win32windows.h>
# include <winsock2.h>
# include <sys/stat.h>

#define  S_IRUSR   _S_IREAD
#define  S_IREAD   _S_IREAD
#define  S_IWUSR   _S_IWRITE
#define  S_IWRITE  _S_IWRITE
#define  S_IXUSR   0100
#define  S_IEXEC   0100
#define  S_IRWXU   (S_IRUSR | S_IWUSR | S_IXUSR)
#define  S_IRGRP   040
#define  S_IWGRP   020

#else
# include <arpa/inet.h>
# include <netdb.h>
# include <netinet/in.h>
# include <sys/stat.h>
# include <sys/socket.h>
# include <sys/wait.h>
#endif

#ifdef _SGIAPI
#  define  socklen_t int
#endif

#endif /* __pisocket_h__ */
