/*
 * Title:   pistring.h
 * Created: Wed May 17 23:08:04 2000
 * Author:  Tim Weyrich
 *
 * Copyright (c) 2000--2002
 * Gilbert Baumann <unk6@rz.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 * 
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 */

#ifndef __PISTRING__
#define __PISTRING__

#include <string.h>
#include <pidefs.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __STRICT_ANSI__
#  ifdef _WIN32
  _CRTIMP char * __cdecl strdup(const char *);
#  else
  extern PI_API char *strdup(const char *s) __PI_THROW;
#  endif
#endif

#ifdef _WIN32
#  define strcasecmp  _strcmpi
#  define snprintf    _snprintf
#  define vsnprintf   _vsnprintf
#elif defined( __STRICT_ANSI__ ) && defined( __GNUC__ )

#  if 1
#    include <stdarg.h>
extern int snprintf (char * __s, size_t __maxlen,
                     const char *__format, ...)
                    __PI_THROW __attribute__ ((__format__ (__printf__, 3, 4)));

extern int vsnprintf (char *__restrict __s, size_t __maxlen,
                      const char *__format, va_list __arg)
                     __PI_THROW __attribute__ ((__format__ (__printf__, 3, 0)));

#  else
extern int snprintf (char *__restrict __s, size_t __maxlen,
                     __const char *__restrict __format, ...)
                    __THROW __attribute__ ((__format__ (__printf__, 3, 4)));

extern int vsnprintf (char *__restrict __s, size_t __maxlen,
                      __const char *__restrict __format, _G_va_list __arg)
                     __THROW __attribute__ ((__format__ (__printf__, 3, 0)));
#  endif
#endif

#if !defined( _WIN32 ) && defined( __STRICT_ANSI__ )

extern PI_API int strcasecmp (const char *__s1, const char *__s2) __PI_THROW;

/* Compare no more than N chars of S1 and S2, ignoring case.  */
extern PI_API int strncasecmp (const char *__s1, const char *__s2,
                               size_t __n) __PI_THROW;
#endif

#ifdef __cplusplus
}
#endif

#endif
