//
// Title:   StringTools.cpp
// Created: Mon Sep 23 14:14:43 2002
// Authors: Oliver Knoll
//
// Copyright (c) 2001, 2002, Computer Graphics Lab, ETH Zurich
//
// This file is part of the Pointshop3D system.
// See http://www.pointshop3d.com/ for more information.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// Contact info@pointshop3d.com if any conditions of this
// licensing are not clear to you.
//

#include <math.h>

#include "StringTools.h"

QString StringTools::appendSequenceNumber (const QString string, const uint sequenceNumber,
										   const uint nofDigits) {

	int     nofNeededDigits,
		    nofZeros,
			i;
	QString newString;

	nofNeededDigits = (int)log10 (sequenceNumber) + 1;
	nofZeros  = nofDigits - nofNeededDigits;

	newString = string;
	for (i = 0; i < nofZeros; i++) {
		newString.append ("0");
	}
	newString.append (QString::number (sequenceNumber));

	return newString;

}

int StringTools::getSequenceNumber (const QString string, const uint nofDigits, const uint position) {

	QString sequenceNumberString;
	int     sequenceNumber;
	bool    isNumber;

	if (string.length() < nofDigits + position) {
		return -1;
	}

	sequenceNumberString = string.right (nofDigits);

	sequenceNumber = sequenceNumberString.toInt (&isNumber);
	if (isNumber == true) {
		return sequenceNumber;
	}
	else {
		return -1;
	}

}

// Some Emacs-Hints -- please don't remove:
//
//  Local Variables:
//  mode:C++
//  tab-width:4
//  End:
